#!/bin/sh

SRC_TARGET=/tmp/update
DST_TARGET=/

clear

echo 
echo "Check file system version..."
echo
IMAGE_VER=`cat $SRC_TARGET/ver/fsver | cut -c0-4`


if [ $IMAGE_VER -lt 4 ]; then
	echo "Failed!!"
	echo "Patch failed (old file system)"
	echo
else

echo "[ File System (0004 (08.12.31)) patch ]"
echo "========================================"

if [ -f $DST_TARGET/bin/sfdisk ]; then
	echo "Already pathced!"
	echo
else
echo "OK!"

echo
echo -n "Copy new file in /bin..."
rm -rf $DST_TARGET/bin/mkdosfs 	 > /dev/null 2>&1
cp -arf $SRC_TARGET/bin/mkfs.ext2	$DST_TARGET/bin	 > /dev/null 2>&1
cp -arf $SRC_TARGET/bin/fbset		$DST_TARGET/bin > /dev/null 2>&1
cp -arf $SRC_TARGET/bin/sfdisk		$DST_TARGET/bin > /dev/null 2>&1
echo "OK!"

echo
echo -n "Copy new file in /lib..."
## libext2fs.so.2 156521
cp -arf $SRC_TARGET/lib/libext2fs.so.2*			$DST_TARGET/lib > /dev/null 2>&1

## libcom_err.so.2 9967
cp -arf $SRC_TARGET/lib/libcom_err.so.2*		$DST_TARGET/lib > /dev/null 2>&1

## libblkid.so.1 43168
cp -arf $SRC_TARGET/lib/libblkid.so.1*			$DST_TARGET/lib > /dev/null 2>&1

## libuuid.so.1 26996
cp -arf $SRC_TARGET/lib/libuuid.so.1*			$DST_TARGET/lib > /dev/null 2>&1

## libe2p.so.2 28174
cp -arf $SRC_TARGET/lib/libe2p.so.2*			$DST_TARGET/lib > /dev/null 2>&1
echo "OK!"

cp -arf $SRC_TARGET/ver/fsver				$DST_TARGET/ver > /dev/null 2>&1

echo 
echo "Complete"
echo


## if [ -f $DST_TARGET/bin/sfdisk ]; then ...
fi
## if [ $IMAGE_VER -lt 4 ]; then ...
fi

echo
echo "[ File System (0005 (09.03.09)) patch ]"
echo "========================================"

if [ -f $DST_TARGET/lib/librt.so.1 ]; then
	echo "Already pathced!"
	echo
else
	echo "OK!"

	echo
	echo -n "Copy new file in /lib..."
	## librt.so.2 156521
	cp -arf $SRC_TARGET/lib/librt*			$DST_TARGET/lib > /dev/null 2>&1
	
	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo 
	echo "Complete"
	echo
fi

echo
echo "[ File System (0006 (09.05.11)) patch ]"
echo "========================================"

if [ -f $DST_TARGET/lib/libresolv.so.2 ] && [ -f $DST_TARGET/lib/libnss_dns.so.2 ] && [ -d $DST_TARGET/usr/lib/gconv ]; then
	echo "Already pathced!"
	echo
else
	echo "OK!"

	echo
	echo -n "Update config files in /etc..."
	cp -arf $SRC_TARGET/etc/nsswitch.conf			$DST_TARGET/etc > /dev/null 2>&1
	cp -arf $SRC_TARGET/etc/init.d/rcSBB			$DST_TARGET/etc/init.d > /dev/null 2>&1
	echo "OK!"
	
	echo -n "Update script files in /root..."
	cp -arf $SRC_TARGET/root/start.sh			$DST_TARGET/root > /dev/null 2>&1
	echo "OK!"

	echo -n "Copy new file in /lib..."
	## libnss_dns-2.5.so		21,861 bytes
	## libresolv-2.5.so		83,153 bytes
	cp -arf $SRC_TARGET/lib/libnss_dns*			$DST_TARGET/lib > /dev/null 2>&1
	cp -arf $SRC_TARGET/lib/libresolv*			$DST_TARGET/lib > /dev/null 2>&1
	echo "OK!"

	echo -n "Copy new file in /usr/lib/..."
	rm -rf $DST_TARGET/usr/lib/gconv
	cp -arf $SRC_TARGET/usr/lib/gconv			$DST_TARGET/usr/lib > /dev/null 2>&1
	echo "OK!"
	
	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo 
	echo "Complete"
	echo
fi

echo
echo "[ File System (0007 (09.05.18)) patch ]"
echo "========================================"

if [ -f $DST_TARGET/lib/libcurl.so ] && [ -f $DST_TARGET/lib/libnxml.so ] && [ -f $DST_TARGET/usr/lib/libcrypto.so ] && [ -f $DST_TARGET/usr/lib/libssl.so ]; then
	echo "Already pathced!"
	echo
else
	echo "OK!"

	echo -n "Copy new file in /lib..."
	cp -arf $SRC_TARGET/lib/libcurl.so*			$DST_TARGET/lib > /dev/null 2>&1
	cp -arf $SRC_TARGET/lib/libnxml.so*			$DST_TARGET/lib > /dev/null 2>&1
	echo "OK!"

	echo -n "Copy new file in /usr/lib/..."
	cp -arf $SRC_TARGET/usr/lib/libcrypto.so*		$DST_TARGET/usr/lib > /dev/null 2>&1
	cp -arf $SRC_TARGET/usr/lib/libssl.so*			$DST_TARGET/usr/lib > /dev/null 2>&1
	echo "OK!"
	
	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo 
	echo "Complete"
	echo
fi

echo
echo "[ File System (0008 (09.07.11)) patch ]"
echo "========================================"

if [ -f $DST_TARGET/usr/lib/libid3tag.so ]; then
	echo "Already pathced!"
	echo
else
	echo "OK!"

	echo -n "Copy new file in /usr/lib/..."
	cp -arf $SRC_TARGET/usr/lib/libid3tag.so*		$DST_TARGET/usr/lib > /dev/null 2>&1
	echo "OK!"
	
	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo 
	echo "Complete"
	echo
fi

echo
echo "[ File System (0009 (09.07.31)) patch ]"
echo "========================================"

if [ -f $DST_TARGET/usr/lib/libcrypt.so ]; then
	echo "Already pathced!"
	echo
else
	echo "OK!"

	echo -n "Copy new file in /usr/lib/..."
	cp -arf $SRC_TARGET/usr/lib/libcrypt.so		$DST_TARGET/usr/lib > /dev/null 2>&1
	echo "OK!"
	
	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo 
	echo "Complete"
	echo
fi

echo
echo "[ File System (0010 (09.09.03)) patch ]"
echo "========================================"

if [ -f $DST_TARGET/usr/bin/curlftpfs ] && [ -f $DST_TARGET/usr/bin/wget ]; then
	echo "Already pathced!"
	echo
else
	echo "OK!"

	echo -n "Copy new file in /usr/lib/..."
	cp -arf $SRC_TARGET/usr/lib/libfuse.so*		$DST_TARGET/usr/lib > /dev/null 2>&1
	cp -arf $SRC_TARGET/usr/lib/libglib-2.0.so*		$DST_TARGET/usr/lib > /dev/null 2>&1
	cp -arf $SRC_TARGET/usr/lib/libiconv.so*		$DST_TARGET/usr/lib > /dev/null 2>&1
	echo "OK!"

	echo -n "Copy new file in /usr/bin/..."
	cp -arf $SRC_TARGET/usr/bin/curlftpfs		$DST_TARGET/usr/bin > /dev/null 2>&1
	cp -arf $SRC_TARGET/usr/bin/wget		$DST_TARGET/usr/bin > /dev/null 2>&1
	echo "OK!"

	echo -n "Copy new file in /bin/..."
	rm -rf $DST_TARGET/bin/wget
	rm -rf $DST_TARGET/bin/mount
	cp -arf $SRC_TARGET/bin/mount		$DST_TARGET/bin > /dev/null 2>&1
	echo "OK!"

	echo -n "Copy new file in /etc/init.d/..."
	cp -arf $SRC_TARGET/etc/init.d/rcSBB		$DST_TARGET/etc/init.d > /dev/null 2>&1
	echo "OK!"

	echo -n "Copy new file in /dev/..."
	cp -arf $SRC_TARGET/dev/fuse		$DST_TARGET/dev > /dev/null 2>&1
	echo "OK!"

	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo 
	echo "Complete"
	echo
fi

echo
echo "[ game patch ]"
echo "========================================"

if [ -d $SRC_TARGET/var/log ] && [ -d $SRC_TARGET/var/run ]; then
	mkdir -p $DST_TARGET/{var/log,var/run} > /dev/null 2>&1
fi

if [ -f $SRC_TARGET/usr/lib/libexpat.so ] && [ ! -f $DST_TARGET/usr/lib/libexpat.so ]; then
	echo -n "Copy libs for game option..."
	cp -arf $SRC_TARGET/usr/lib/libexpat*		$DST_TARGET/usr/lib > /dev/null 2>&1
else if [ ! -f $SRC_TARGET/usr/lib/libexpat.so ]; then
	echo -n "Removing libs for game option..."
	rm -rf $DST_TARGET/usr/lib/libexpat* > /dev/null 2>&1
fi
fi 

if [ -f $SRC_TARGET/usr/lib/libSDL-1.2.so.0 ] && [ ! -f $DST_TARGET/usr/lib/libSDL-1.2.so.0 ]; then
	cp -arf $SRC_TARGET/usr/lib/libSDL-1.2.so.0*		$DST_TARGET/usr/lib > /dev/null 2>&1
else if [ ! -f $SRC_TARGET/usr/lib/libSDL-1.2.so.0 ]; then
	rm -rf $DST_TARGET/usr/lib/libSDL-1.2.so.0* > /dev/null 2>&1
fi
fi 

if [ -f $SRC_TARGET/usr/lib/libSDL_image-1.2.so.0 ] && [ ! -f $DST_TARGET/usr/lib/libSDL_image-1.2.so.0 ]; then
	cp -arf $SRC_TARGET/usr/lib/libSDL_image-1.2.so.0*		$DST_TARGET/usr/lib > /dev/null 2>&1
else if [ ! -f $SRC_TARGET/usr/lib/libSDL_image-1.2.so.0 ]; then
	rm -rf $DST_TARGET/usr/lib/libSDL_image* > /dev/null 2>&1
fi
fi 

if [ -f $SRC_TARGET/usr/lib/liblirc_client.so ] && [ ! -f $DST_TARGET/usr/lib/liblirc_client.so ]; then
	cp -arf $SRC_TARGET/usr/lib/liblirc_client.so*		$DST_TARGET/usr/lib > /dev/null 2>&1
else if [ ! -f $SRC_TARGET/usr/lib/liblirc_client.so ]; then
	rm -rf $DST_TARGET/usr/lib/liblirc_client.so* > /dev/null 2>&1
fi
fi 

if [ -f $SRC_TARGET/usr/lib/libasound.so ] && [ ! -f $DST_TARGET/usr/lib/libasound.so ]; then
	cp -arf $SRC_TARGET/usr/lib/libasound.so*		$DST_TARGET/usr/lib > /dev/null 2>&1
else if [ ! -f $SRC_TARGET/usr/lib/libasound.so ]; then
	rm -rf $DST_TARGET/usr/lib/libasound.so* > /dev/null 2>&1
fi
fi 

if [ -f $SRC_TARGET/lib/libnss_files.so.2 ] && [ ! -f $DST_TARGET/lib/libnss_files.so.2 ]; then
	cp -arf $SRC_TARGET/lib/libnss_files*		$DST_TARGET/lib > /dev/null 2>&1
else if [ ! -f $SRC_TARGET/lib/libnss_files.so.2 ]; then
	rm -rf $DST_TARGET/lib/libnss_files* > /dev/null 2>&1
fi
fi 

if [ -f $SRC_TARGET/usr/bin/lircrcd ] && [ ! -f $DST_TARGET/usr/bin/lircrcd ]; then
	cp -arf $SRC_TARGET/usr/bin/lircrcd		$DST_TARGET/usr/bin > /dev/null 2>&1
	cp -arf $SRC_TARGET/usr/sbin/lircd		$DST_TARGET/usr/sbin > /dev/null 2>&1
	cp -arf $SRC_TARGET/etc/{lircd.conf,lircrc}		$DST_TARGET/etc  > /dev/null 2>&1
else if [ ! -f $SRC_TARGET/usr/bin/lircrcd ]; then
	rm -rf $DST_TARGET/usr/bin/lircrcd > /dev/null 2>&1
	rm -rf $DST_TARGET/usr/sbin/lircd > /dev/null 2>&1
	rm -rf $DST_TARGET/etc/{lircd.conf,lircrc} > /dev/null 2>&1
else
	cp -arf $SRC_TARGET/etc/{lircd.conf,lircrc}		$DST_TARGET/etc  > /dev/null 2>&1
fi
fi 

if [ -f $SRC_TARGET/root/gamelauncher.out ]; then
	cp -arf $SRC_TARGET/root/gamelauncher.out			$DST_TARGET/root > /dev/null 2>&1
else
	rm -rf $DST_TARGET/root/gamelauncher.out > /dev/null 2>&1
fi 

if [ -f $SRC_TARGET/root/modules/lirc_dev.ko ] && [ -f $SRC_TARGET/root/modules/lirc_stm.ko ]; then
	cp -arf $SRC_TARGET/root/modules/lirc_dev.ko			$DST_TARGET/root/modules > /dev/null 2>&1
	cp -arf $SRC_TARGET/root/modules/lirc_stm.ko			$DST_TARGET/root/modules > /dev/null 2>&1
else
	rm -rf $DST_TARGET/root/modules/lirc_dev.ko > /dev/null 2>&1
	rm -rf $DST_TARGET/root/modules/lirc_stm.ko > /dev/null 2>&1
fi 

	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo "OK!"

echo 
echo "Complete"
echo


echo
echo "[ File System extra patch ]"
echo "========================================"

if [ -f $DST_TARGET/lib/libcurl.so ] || [ -f $DST_TARGET/lib/libnxml.so ]; then
	echo -n "Overwrite file in /lib...(curl, nxml)"
	cp -arf $SRC_TARGET/lib/libcurl.so*			$DST_TARGET/lib > /dev/null 2>&1
	cp -arf $SRC_TARGET/lib/libnxml.so*			$DST_TARGET/lib > /dev/null 2>&1
	echo "OK!"

	echo -n "Remove unused resource file in /root...(curl, nxml)"
	rm -rf $DST_TARGET/root/images/*
	rm -rf $DST_TARGET/root/fonts/*
	echo "OK!"

	if [ ! -c $DST_TARGET/dev/micom ]; then
		echo -n "Make micom device in /dev/..."
		mknod $DST_TARGET/dev/micom c 119 0
		echo "OK!"
	fi

	if [ -f $SRC_TARGET/usr/bin/jpgtn ] && [ ! -f $DST_TARGET/usr/bin/jpgtn ]; then
		echo -n "copy jpgtn in /usr/bin/..."
		cp -arf $SRC_TARGET/usr/bin/jpgtn			$DST_TARGET/usr/bin/jpgtn > /dev/null 2>&1
		echo "OK!"
	fi

	cp -arf $SRC_TARGET/ver/fsver			$DST_TARGET/ver > /dev/null 2>&1

	echo 
	echo "Complete"
	echo
fi


if [ -d $SRC_TARGET/usr/lib/gconv ]; then
echo
echo "[ Language system patch ]"
echo "========================================"

echo -n "Copy new file in /usr/lib/..."
rm -rf $DST_TARGET/usr/lib/gconv
cp -arf $SRC_TARGET/usr/lib/gconv			$DST_TARGET/usr/lib > /dev/null 2>&1
echo "OK!"
fi

if [ ! -e $DST_TARGET/dev/tty ]; then
echo
echo "[ dev tty device file patch ]"
echo "========================================"

echo -n "Copy dev/tty file in /dev/..."
cp -arf $SRC_TARGET/dev/tty* 				$DST_TARGET/dev/ > /dev/null 2>&1
echo "OK!"
fi

echo
echo "========================================"
echo "upgrade FAE -> SDK"
echo "========================================"

if [ -f $DST_TARGET/root/main_hmp_7109_LINUX.out ]; then
	echo "<!> FAE found <!>"
	echo -n "  remove FAE files..."

	rm -rf $DST_TARGET/root/modules
	rm -rf $DST_TARGET/root/fonts
	rm -rf $DST_TARGET/root/images
	rm -rf $DST_TARGET/root/*.out
	rm -rf $DST_TARGET/root/*.sh
	rm -rf $DST_TARGET/root/*.txt
	echo "OK!"
else
	echo "SDK found"
	echo "Continue to SW update"
fi


return 0

